﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.InteropServices;
using System.Windows.Forms;
using Excel = Microsoft.Office.Interop.Excel;

namespace Excel2SapBom
{

    public class ExcelClass
    {
        private static Excel.Application application;
        private Excel.Workbooks workbooks;
        private Excel.Workbook workbook;
        private Excel.Worksheet worksheet;
        private Excel.Range rangeA;
        private Excel.Range rangeB;

        public static void OpenExcel()
        {
            try
            {
                application = (Excel.Application)Marshal.GetActiveObject("Excel.Application");
            }
            catch
            {
                application = new Excel.Application();
            }
            finally
            {
                application.Visible = true;
            }
        }

        public static void CloseExcel()
        {
            if (application != null)
            {
                application.Quit();
                Marshal.FinalReleaseComObject(application);
                application = null;
            }
        }

        public Boolean ReadBom(ref Object[,] positions, out String matnr)
        {
            if (application == null)
            {
                try
                {
                    application = (Excel.Application)Marshal.GetActiveObject("Excel.Application");
                    application.Visible = true;
                }
                catch
                {
                    MessageBox.Show("Can't find any Excel.Application");
                    matnr = "";
                    return false;
                }
            }

            try
            {
                application.Visible = true;
                workbooks = application.Workbooks;

                if (workbooks.Count == 0)
                {
                    workbooks.Add();
                }

                workbook = application.ActiveWorkbook;
                worksheet = workbook.ActiveSheet;

                rangeA = worksheet.get_Range("A1");
                rangeA.Select();
                matnr = ((Object)(rangeA.Value)).ToString();

                rangeA = worksheet.get_Range("A4:F4");
                rangeB = rangeA.get_End(Excel.XlDirection.xlDown);

                rangeB = worksheet.get_Range(rangeA, rangeB);
                rangeB.Select();

                positions = rangeB.Value;
                return true;
            }
            catch (Exception e)
            {
                MessageBox.Show(e.Message);
                matnr = "";
                return false;
            }
        }
    }
}